
public class ExploreParseInt {

	public static void main(String[] args) {
		
		String value = "100";

		// Rechne value in verschiedene Systeme um
		System.out.println("2er System: "+Integer.parseInt(value,2));
		System.out.println("3er System: "+Integer.parseInt(value,3));
		System.out.println("4er System: "+Integer.parseInt(value,4));
		System.out.println("5er System: "+Integer.parseInt(value,5));
		System.out.println("6er System: "+Integer.parseInt(value,6));
		System.out.println("7er System: "+Integer.parseInt(value,7));
		System.out.println("8er System: "+Integer.parseInt(value,8));
		System.out.println("9er System: "+Integer.parseInt(value,9));
		System.out.println("10er System: "+Integer.parseInt(value,10));
		System.out.println("16er System: "+Integer.parseInt(value,16));
		System.out.println("20er System: "+Integer.parseInt(value,20));
		System.out.println("36er System: "+Integer.parseInt(value,36)+"\n");

		// Vergleiche Integer.parseInt mit fastParse
		comparseParseInt(value);
	}

	/**
	 * Measure times for Integer.parseInt and fastParse. Take the best of 1000
	 * cycles
	 */
	private static void comparseParseInt(String value) {
		int n = 100000; // How many computations
		
		long min1 = Long.MAX_VALUE;
		long min2 = Long.MAX_VALUE;
		long t0, dt;
		for (int i=0;i<100;i++) {
			
			// Measure Integer.parseInt
			t0 = System.nanoTime();
			for (int j=0;j<n;j++) {
				Integer.parseInt(value,10);
			}
			
			dt = System.nanoTime()-t0;
			min1 = Math.min(min1, dt);
			

			// Measure fastParse
			t0 = System.nanoTime();
			for (int j=0;j<n;j++) {
				fastParse(value,10);
			}
			
			dt = System.nanoTime()-t0;
			min2 = Math.min(min2, dt);
		}
		
		System.out.println("Integer.parseInt: "+min1/1000+" mms fr 100'000 Durchlufe");
		System.out.println("       fastParse: "+min2/1000+" mms fr 100'000 Durchlufe");
	}

	/**
	 * Rechne einen String in eine Zahl um. Die gltigkeit des Strings wird
	 * nicht berprft, also keine Exceptions ausgelst und die Methode ist nur
	 * fr Zahlensysteme bis 10 sinnvoll.
	 */
	private static int fastParse(String value, int radix) {
		int ret = 0;
		for (int i=0;i<value.length();i++) {
			/*
			 * charAt(i) gibt den i-ten char zurck. '0' hat den Wert 48, '1'
			 * hat den Wert 49, usw.
			 */
			ret = ret*radix + (value.charAt(i)-48);
		}
		return ret;	
	}
}
